<template>
  <i-wrapper top>
    <i-header :title="$t(`Settings`)" back />
    <div class="container d-flex flex-column align-items-center">
      <div class="p-wrapper">
        <input class="p-name-input" v-model="auth.user.name" readonly @click="changeUserName()" />
        <button type="button" class="p-change-name-button" @click="changeUserName()">{{ $t(`Change name`) }}</button>
        <div class="p-settings">
          <div class="p-setting" @click="onSettingClick('notifications')">
            <img src="~assets/images/setting-notifications.svg" class="p-setting__image" />
            <div class="p-setting__body">
              <div class="p-setting__title">{{ $t(`Daily notifications`) }}</div>
              <div class="p-setting__value">{{ receiveNotificationsAtString }}</div>
            </div>
            <div class="p-setting__switcher">
              <i-switcher :value="!!receiveNotificationsAt" ref="switcher" />
            </div>
          </div>
          <nuxt-link class="p-setting" :to="{ name: 'settings.birth-date-and-time' }">
            <img src="~assets/images/setting-calendar.svg" class="p-setting__image" />
            <div class="p-setting__body">
              <div class="p-setting__title">{{ $t(`Date and time of birth`) }}</div>
              <div class="p-setting__value">{{ dateAndTimeOfBirthString }}</div>
            </div>
            <img src="~assets/images/setting-arrow.svg" class="p-setting__arrow" />
          </nuxt-link>
          <nuxt-link class="p-setting" :to="{ name: 'settings.birth-place' }">
            <img src="~assets/images/setting-place.svg" class="p-setting__image" />
            <div class="p-setting__body">
              <div class="p-setting__title">{{ $t(`Place of birth`) }}</div>
              <div class="p-setting__value">{{ placeOfBirthString }}</div>
            </div>
            <img src="~assets/images/setting-arrow.svg" class="p-setting__arrow" />
          </nuxt-link>
          <nuxt-link class="p-setting" :to="{ name: 'support' }">
            <img src="~assets/images/setting-subscription.svg" class="p-setting__image" />
            <div class="p-setting__body">
              <div class="p-setting__title">{{ $t(`Manage subscription`) }}</div>
            </div>
            <img src="~assets/images/setting-arrow.svg" class="p-setting__arrow" />
          </nuxt-link>
          <nuxt-link class="p-setting" :to="localePath({ name: 'about-us' })">
            <img src="~assets/images/setting-about-us.svg" class="p-setting__image" />
            <div class="p-setting__body">
              <div class="p-setting__title">{{ $t(`About Us`) }}</div>
            </div>
            <img src="~assets/images/setting-arrow.svg" class="p-setting__arrow" />
          </nuxt-link>
          <div class="p-setting">
            <img src="~assets/images/setting-logout.svg" class="p-setting__image p-setting__image--s-18" />
            <div class="p-setting__body" @click="logout()">
              <div class="p-setting__title">{{ $t(`Log Out`) }}</div>
            </div>
          </div>
        </div>
        <i-input
          ref="receiveNotificationsAtInput"
          v-model="receiveNotificationsAt"
          :default-value="defaultTime"
          type="time"
          :flow="['time']"
          hidden
          @input="onReceiveNotificationsAtChanged" />
      </div>
    </div>
  </i-wrapper>
</template>

<script>
  import { mapState } from 'vuex';

  export default {
    layout: 'default',
    nuxtI18n: false,
    middleware: ['logged-in-only'],
    transition: { name: 'fade', mode: 'out-in' },

    data() {
      return {
        receiveNotificationsAt: this.$store.state.auth.user.receiveNotificationsAt
          ? `1970-01-01T${this.$store.state.auth.user.receiveNotificationsAt}`
          : null,
        defaultTime: '1970-01-01T12:00:00',
        isMounted: false,
      };
    },

    computed: {
      ...mapState(['auth']),

      receiveNotificationsAtString() {
        return this.receiveNotificationsAt
          ? this.$moment(this.receiveNotificationsAt).format('hh:mm A')
          : this.$t(`Don't receive`);
      },

      dateAndTimeOfBirthString() {
        return this.$moment(this.auth.user.birthDate + 'T' + (this.auth.user.birthTime || '00:00:00')).format(
          'DD MMMM, YYYY, hh:mm A'
        );
      },

      placeOfBirthString() {
        return this.$store.state.auth.user.birthPlace
          ? this.$store.state.auth.user.birthPlace.description.split(/,/)[0].trim()
          : 'Unknown';
      },
    },

    mounted() {
      this.isMounted = true;
    },

    methods: {
      async changeUserName() {
        let newUserName = prompt('Type your Name', this.$store.state.auth.user.name);

        if (!newUserName) {
          return;
        }

        let response = await this.$axios.post('users/me/update', {
          user: { name: newUserName },
        });

        this.$store.commit('MERGE_AUTH', { user: response.data.data });
      },

      async onSettingClick(settingType) {
        if (settingType === 'notifications') {
          if (!this.receiveNotificationsAt) {
            this.$refs.receiveNotificationsAtInput.$refs.root.querySelector('.i-input__input').click();
            this.$refs.receiveNotificationsAtInput.data = this.defaultTime;
            return;
          }

          this.$refs.switcher.isOn = false;
          this.receiveNotificationsAt = null;

          let response = await this.$axios.post('users/me/update', {
            user: { receiveNotificationsAt: null },
          });

          this.$store.commit('MERGE_AUTH', { user: response.data.data });
        }
      },

      async onReceiveNotificationsAtChanged() {
        if (this.isMounted) {
          console.log(this.receiveNotificationsAt);

          if (this.receiveNotificationsAt) {
            this.$refs.switcher.isOn = true;

            let response = await this.$axios.post('users/me/update', {
              user: {
                receiveNotificationsAt: this.$moment(this.receiveNotificationsAt).format('HH:mm:ss'),
              },
            });

            this.$store.commit('MERGE_AUTH', { user: response.data.data });
          } else {
            this.$refs.switcher.isOn = false;
          }
        }
      },

      async logout() {
        await this.$store.dispatch('logout');
        await this.$router.push(this.localePath({ name: 'index' }));
      },
    },
  };
</script>

<style lang="scss" scoped>
  .p-wrapper {
    display: flex;
    flex-direction: column;
    width: 100%;
    padding: 0 rs(20px);
  }

  .p-name-input {
    width: 100%;
    height: rs(40px);
    text-align: center;
    font-size: rf(20px);
    font-weight: bold;
    color: #fff;
    background-color: rgba(#ca5a4e, 20%);
    border: 0;
    border-radius: rs(20px);
    padding: 0 rs(20px);
    cursor: pointer;

    &:focus {
      outline: none;
    }
  }

  .p-change-name-button {
    display: flex;
    width: 100%;
    height: rs(20px);
    align-items: center;
    justify-content: center;
    background-color: transparent;
    border: 0;
    font-size: rf(14px);
    color: #fff;
    cursor: pointer;
    margin-top: rs(10px);
  }

  .p-settings {
    width: 100%;
    margin-top: rs(25px);
  }

  .p-setting {
    display: flex;
    width: 100%;
    cursor: pointer;
    padding-top: rs(7px);
    padding-bottom: rs(7px);
    border-bottom: rs(1px) solid rgba(#fff, 40%);
    // margin-bottom: rs(2px);
    text-decoration: none;
  }

  .p-setting__image {
    width: rs(20px);
    height: rs(20px);
    margin-right: rs(10px);
    margin-top: rs(2px);

    &--s-18 {
      padding: rs(1px);
    }
  }

  .p-setting__body {
    display: flex;
    width: 100%;
    flex-grow: 1;
    flex-direction: column;
    justify-content: center;
  }

  .p-setting__title {
    color: #fff;
    font-size: rf(16px);
  }

  .p-setting__value {
    color: #fff;
    font-size: rf(14px);
  }

  .p-setting__arrow {
    width: rs(7px);
    height: rs(12px);
    align-self: center;
  }

  .p-setting__switcher {
    margin-top: rs(2px);
  }
</style>
